#!/usr/local/bin/perl
{
}
sub extract_short_entry_print {

   local($num_dept, *dept_arr, *array, *entry) = @_;
   local ($input, $dept, $date, $time, $speak, $title, $tmp, $organ);
   local ($dept_name, $abstract, $other, $type);

   $organ = $array{"organ_type"};
   if ($organ =~ /Department/ ) { $organ = ""; }

   $dept      = $array{"dept"};
   $date      = $array{"date"};
   $time      = $array{"time"};
   $locat     = $array{"locat"};
   $type      = $array{"event_type"};
   $affil     = $array{"affil"};
   $affil =~ s/\n+/ <EM>and<\/EM> /g;
   $speak     = $array{"speak"};
   $title     = $array{"t_title"};
   $abstract  = $array{"t_abstract"};
   $abstract =~ s/\n(\s*\n)+/<P>/g;
   if($abstract eq "TBA") { $abstract = ""};
   $other     = $array{"other_info"};
   $linkto    = $array{"link_to"};
   $modified  = $array{"modified"};

   $dept_name = " -- ".$dept_arr{$dept};
   if( $num_dept == 1) {
     $dept_name = " ";
   }

   if($modified eq "false") {$modified = "";}

   if($modified =~ /delete/) {
      $entry = "\n<DT><B>$date, $time <EM> *** CANCELLED *** </EM> </B><BR>\n"; 
      $entry .= "<em>$organ $type</em> $dept_name\n";
      $entry .= "<DD>$speak, $affil<BR> <B><EM>\"$title\"</EM></B><BR>\n";
      $entry .= "<BR>\n";
   }
   elsif ($modified =~ /moved/ )  {
      $new_date = $array{"new_date"};
      $new_time = $array{"new_time"};
      if( $new_date eq $date) {
	 $tmp = "<B><I> ** Time Change **</I></B> - now at <B><I>$new_time</I></B>";
      }
      else {
	 $tmp = "<B><I> ** Date Change **</I></B> - now <B><I> $new_date, $new_time</I></B>";
      }
      $entry = "\n<DT><B> $date, $time</B> -  $tmp\n"; 
      $entry .="<BR><EM>** See updated entry for additional event information **</em>\n";
#      $entry .= "<DT><em>$organ $type</em> $dept_name\n";
      $entry .= "<DD><em>Speaker:</em> $speak, $affil<BR><em>Title:</em> <B><EM>\"$title\"</EM></B><BR>\n";
      $entry .= "<BR>\n";
   }
   else {
      $entry = "\n<DT><B>$date,  $time </B> -- $locat  $modified\n"; 
      $entry .= "<DT><em>$organ $type</em> $dept_name\n";
      $entry .= "<DD><em>Speaker:</em> $speak, $affil<BR><em>Title:</em> <B><EM>\"$title\"</EM></B><BR>\n";
      if( $other ne "" ) {
	$entry .= "<EM>Remarks:</EM> $other <BR>\n";
      }
      if( $abstract ne "" ) {
	$entry .= "<EM>Abstract:</EM> $abstract <BR>\n";
      }
      $entry .= "<BR>\n";
   }
   return(1);
}

sub extract_short_entry_bygroup_print {

   local($num_grps, *organ_arr, *array, *entry) = @_;
   local ($input, $dept, $date, $time, $speak, $title, $tmp, $organ);
   local ($dept_name, $abstract, $other, $type);

   $organ = $array{"organ_type"};
   if ($organ =~ /Department/ ) { $organ = "Departmental Event"; }

   $dept      = $array{"dept"};
   $date      = $array{"date"};
   $time      = $array{"time"};
   $locat     = $array{"locat"};
   $type      = $array{"event_type"};
   $affil     = $array{"affil"};
   $affil =~ s/\n+/ <EM>and<\/EM> /g;
   $speak     = $array{"speak"};
   $title     = $array{"t_title"};
   $abstract  = $array{"t_abstract"};
   $abstract =~ s/\n(\s*\n)+/<P>/g;
   if($abstract eq "TBA") { $abstract = ""};
   $other     = $array{"other_info"};
   $linkto    = $array{"link_to"};
   $modified  = $array{"modified"};

   if( $num_grps == 1) {
     $organ =  "";
   }
   else {
     $organ = $organ."  ";
   }

   if($modified eq "false") {$modified = "";}
   
   if($modified =~ /delete/) {
      $entry = "\n<DT><B>$date, $time <EM> *** CANCELLED *** </EM> </B><BR>\n"; 
      $entry .= "<em>$organ $type</em>\n";
      $entry .= "<DD>$speak, $affil<BR> <B><EM>\"$title\"</EM></B><BR>\n";
      $entry .= "<BR>\n";
   }
   elsif ($modified =~ /moved/ )  {
      $new_date = $array{"new_date"};
      $new_time = $array{"new_time"};
      if( $new_date eq $date) {
	 $tmp = "<B><I> ** Time Change **</I></B> - now at <B><I>$time</I></B>";
      }
      else {
	 $tmp = "<B><I> ** Date Change **</I></B> - now <B><I> $date, $time</I></B>";
      }
      $entry = "\n<DT><B> $date, $time</B> -  $tmp\n"; 
      $entry .="<BR><EM>** See updated entry for additional event information **</em>\n";
#      $entry .= "<DT><em>$organ $type</em> $dept_name\n";
      $entry .= "<DD><em>Speaker:</em> $speak, $affil<BR><em>Title:</em> <B><EM>\"$title\"</EM></B><BR>\n";
      $entry .= "<BR>\n";
   }
   else {
      $entry = "\n<DT><B>$date,  $time </B> -- $locat  $modified\n"; 
      $entry .= "<DT><em>$organ $type</em>\n";
      $entry .= "<DD><em>Speaker:</em> $speak, $affil<BR><em>Title:</em> <B><EM>\"$title\"</EM></B><BR>\n";
      if( $other ne "" ) {
	$entry .= "<EM>Remarks:</EM> $other <BR>\n";
      }
      if( $abstract ne "" ) {
	$entry .= "<EM>Abstract:</EM> $abstract <BR>\n";
      }
      $entry .= "<BR>\n";
   }

   return(1);
}
1;
