#  #!/usr/local/bin/perl
#  $stringgg = "aabcdefghigklym`\"";
#  print "$stringgg\n";;
#  &char_transl(*stringgg);
#  print "$stringgg\n";

sub isotoasc {

   local(*string) = @_;
   local(%chartrans, $char);

# chartrans{} contains a table that maps ISO Latin-1 characters onto
# an ASCII subset.  This is useful for composing plain-text email or
# newsgroup versions of notices, which the web-version may contain
# non-ASCII characters, 

# print  "  In routine $string\n";
%chartrans = (
      pack("C", 0x00),    " ", pack("C", 0x01),    " ", 
      pack("C", 0x02),    " ", pack("C", 0x03),    " ",
      pack("C", 0x04),    " ", pack("C", 0x05),    " ", 
      pack("C", 0x06),    " ", pack("C", 0x07),    " ",
      pack("C", 0x08),    " ", 
      pack("C", 0x09),    pack("C", 0x09), 
      pack("C", 0x0a),    pack("C", 0x0a),
      pack("C", 0x0b),    " ",
      pack("C", 0x0c),    pack("C", 0x0c), 
      pack("C", 0x0d),    pack("C", 0x0d),
      pack("C", 0x0e),    " ", pack("C", 0x0f),    " ",
      pack("C", 0x10),    " ", pack("C", 0x11),    " ", 
      pack("C", 0x12),    " ", pack("C", 0x13),    " ",
      pack("C", 0x14),    " ", pack("C", 0x15),    " ", 
      pack("C", 0x16),    " ", pack("C", 0x17),    " ",
      pack("C", 0x18),    " ", pack("C", 0x19),    " ", 
      pack("C", 0x1a),    " ", pack("C", 0x1b),    " ",
      pack("C", 0x1c),    " ", pack("C", 0x1d),    " ", 
      pack("C", 0x1e),    " ", pack("C", 0x1f),    " ",
      " ",     " ", "!",     "!", "\"",    "\"", "#",    "#",
      "$",     "$", "%",     "%", "&",     "&", "'",     "'",
      "(",     "(", ")",     ")", "*",     "*", "+",     "+",
      ",",     ",", "-",     "-", ".",     ".", "/",     "/",
      "0",     "0", "1",     "1", "2",     "2", "3",     "3",
      "4",     "4", "5",     "5", "6",     "6", "7",     "7",
      "8",     "8", "9",     "9", ":",     ":", ";",     ";",
      "<",     "<", "=",     "=", ">",     ">", "?",     "?",
      "@",     "@", "A",     "A", "B",     "B", "C",     "C",
      "D",     "D", "E",     "E", "F",     "F", "G",     "G",
      "H",     "H", "I",     "I", "J",     "J", "K",     "K",
      "L",     "L", "M",     "M", "N",     "N", "O",     "O",
      "P",     "P", "Q",     "Q", "R",     "R", "S",     "S",
      "T",     "T", "U",     "U", "V",     "V", "W",     "W",
      "X",     "X", "Y",     "Y", "Z",     "Z", "[",     "[",
      "\\",    "\\", "]",    "]", "^",     "^", "_",     "_",
      "`",     "`", "a",     "a", "b",     "b", "c",     "c",
      "d",     "d", "e",     "e", "f",     "f", "g",     "g",
      "h",     "h", "i",     "i", "j",     "j", "k",     "k",
      "l",     "l", "m",     "m", "n",     "n", "o",     "o",
      "p",     "p", "q",     "q", "r",     "r", "s",     "s",
      "t",     "t", "u",     "u", "v",     "v", "w",     "w",
      "x",     "x", "y",     "y", "z",     "z", "{",     "{",
      "|",     "|", "}",     "}", "~",     "~", 
      pack("C", 0x7f),    pack("C", 0x7f),
      pack("C", 0x80),    " ", pack("C", 0x81),    " ", 
      pack("C", 0x82),    " ", pack("C", 0x83),    " ", 
      pack("C", 0x84),    " ",
      pack("C", 0x85),    " ", pack("C", 0x86),    " ", 
      pack("C", 0x87),    " ", pack("C", 0x88),    " ", 
      pack("C", 0x89),    " ",
      pack("C", 0x8a),    " ", pack("C", 0x8b),    " ", 
      pack("C", 0x8c),    " ", pack("C", 0x8d),    " ", 
      pack("C", 0x8e),    " ",
      pack("C", 0x8f),    " ", pack("C", 0x90),    " ", 
      pack("C", 0x91),    " ", pack("C", 0x92),    " ", 
      pack("C", 0x93),    " ",
      pack("C", 0x94),    " ", pack("C", 0x95),    " ", 
      pack("C", 0x96),    " ", pack("C", 0x97),    " ", 
      pack("C", 0x98),    " ",
      pack("C", 0x99),    " ", pack("C", 0x9a),    " ", 
      pack("C", 0x9b),    " ", pack("C", 0x9c),    " ", 
      pack("C", 0x9d),    " ",
      pack("C", 0x9e),    " ", pack("C", 0x9f),    " ", 
      pack("C", 0xa0),    " ", pack("C", 0xa1),    "!", 
      pack("C", 0xa2),    "cents",
      pack("C", 0xa3),    "Pounds", pack("C", 0xa4),    "*", 
      pack("C", 0xa5),    "Yen", pack("C", 0xa6),    "|", 
      pack("C", 0xa7),    "*",
      pack("C", 0xa8),    "..", pack("C", 0xa9),    "(C)", 
      pack("C", 0xaa),    " ", pack("C", 0xab),    "<<", 
      pack("C", 0xac),    "-",
      pack("C", 0xad),    "-", pack("C", 0xae),    "(R)", 
      pack("C", 0xaf),    "-", pack("C", 0xb0),    "deg", 
      pack("C", 0xb1),    "+/-",
      pack("C", 0xb2),    "^2", pack("C", 0xb3),    "^3", 
      pack("C", 0xb4),    "'", pack("C", 0xb5),    "u", 
      pack("C", 0xb6),    " ",
      pack("C", 0xb7),    ".", pack("C", 0xb8),    " ", 
      pack("C", 0xb9),    "^1", pack("C", 0xba),    " ", 
      pack("C", 0xbb),    ">>",
      pack("C", 0xbc),    "1/4", pack("C", 0xbd),    "1/2", 
      pack("C", 0xbe),    "3/4", pack("C", 0xbf),    "?", 
      pack("C", 0xc0),    "A",
      pack("C", 0xc1),    "A", pack("C", 0xc2),    "A", 
      pack("C", 0xc3),    "A", pack("C", 0xc4),    "A", 
      pack("C", 0xc5),    "A",
      pack("C", 0xc6),    "E", pack("C", 0xc7),    "C", 
      pack("C", 0xc8),    "E", pack("C", 0xc9),    "E", 
      pack("C", 0xca),    "E",
      pack("C", 0xcb),    "E", pack("C", 0xcc),    "I", 
      pack("C", 0xcd),    "I", pack("C", 0xce),    "I", 
      pack("C", 0xcf),    "I",
      pack("C", 0xd0),    "D", pack("C", 0xd1),    "N", 
      pack("C", 0xd2),    "O", pack("C", 0xd3),    "O", 
      pack("C", 0xd4),    "O",
      pack("C", 0xd5),    "O", pack("C", 0xd6),    "O", 
      pack("C", 0xd7),    "X", pack("C", 0xd8),    "O", 
      pack("C", 0xd9),    "U",
      pack("C", 0xda),    "U", pack("C", 0xdb),    "U", 
      pack("C", 0xdc),    "U", pack("C", 0xdd),    "Y", 
      pack("C", 0xde),    "P",
      pack("C", 0xdf),    "ss", pack("C", 0xe0),    "a", 
      pack("C", 0xe1),    "a", pack("C", 0xe2),    "a", 
      pack("C", 0xe3),    "a",
      pack("C", 0xe4),    "a", pack("C", 0xe5),    "a", 
      pack("C", 0xe6),    "ae", pack("C", 0xe7),    "C", 
      pack("C", 0xe8),    "e",
      pack("C", 0xe9),    "e", pack("C", 0xea),    "e", 
      pack("C", 0xeb),    "e", pack("C", 0xec),    "i", 
      pack("C", 0xed),    "i",
      pack("C", 0xee),    "i", pack("C", 0xef),    "i", 
      pack("C", 0xf0),    "o", pack("C", 0xf1),    "n", 
      pack("C", 0xf2),    "o",
      pack("C", 0xf3),    "o", pack("C", 0xf4),    "o", 
      pack("C", 0xf5),    "o", pack("C", 0xf6),    "o", 
      pack("C", 0xf7),    "/",
      pack("C", 0xf8),    "o", pack("C", 0xf9),    "u", 
      pack("C", 0xfa),    "u", pack("C", 0xfb),    "u", 
      pack("C", 0xfc),    "u",
      pack("C", 0xfd),    "y", pack("C", 0xfe),    "p", 
      pack("C", 0xff),    "y"
    );

$* =1;
$string =~ s/(.)/$chartrans{$1}/g;

}
1;
