#! /usr/local/bin/perl
#
# ------------------------------------------------------------------------
# WebNotice --  Web/CGI Notice Posting Software
#
# Copyright (c) 1995 Ian Graham
#                    Information Commons
#                    University of Toronto
# 
# Permission to use, copy, modify and distribute without fee any portion 
# of this software and its documentation, for any purpose, is hereby granted 
# without fee, provided that (i) the above copyright notices and this 
# permission notice appear in all copies of the software and related 
# documentation, and (ii) the name of Ian Graham and The University of 
# Toronto may not be used in any advertising or publicity relating to 
# the software without the specific, prior written permission of Ian Graham.
# 
# THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
# 
# IN NO EVENT SHALL IAN GRAHAM OR THE UNIVERSITY OF TORONTO BE LIABLE FOR
# ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
# OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
# WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
# LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
# OF THIS SOFTWARE.
# ------------------------------------------------------------------------
#
# notices_main.pl
#
# Revision:  1.0
# Date:      2 February 1995
# Author:    Ian Graham <ian.graham@utoronto.ca>
#
# This program generates the introductory page for the Notices distribution
# system.   It generates and HTML page pointing to the "Add", "View", and
# "Modify" notices pages, and has icons that point to explanatory information.

# Debug Use variable $DEBUG to set debug mode.

# $DEBUG = 1;

require 'lib/configure.ph';
require 'lib/utils.pl';

open(TEMPLATE,$notices_main_tmpl) ||
   &f_error("Unable to open $notices_main_tmpl --\n ", __LINE__,__FILE__);
@page = <TEMPLATE>;

foreach $one (@page) {
   $one =~ s/\<T_CGI_DIR\>/$cgi_dir/g;
   $one =~ s/\<T_DOC_DIR\>/$rel_doc_dir/g;
}


print "Content-type: text/html\n\n";
print @page;
