# Installation program (perl).   Stupid, but it works.

require 'configure.ph';      # Generic configuration information 
require 'config_adm.ph';     # Configuration information for admini scripts.
require 'config_cron.ph';    # Configuration information for cron scripts
require 'config_install.ph'; # Definitions required only for installation.

$perlpath = "#! ".$ARGV[0];  # perl path passed as arg from install.sh

print STDOUT <<EOF;


                  ********************************
             INSTALLATION PROGRAM FOR WEB NOTICES SYSTEM
                  ********************************

Installation locations are taken from the 'configure.ph' header file in 
this directory. If you got error messages right at the start, you probably
made a mistake editing this file  -- did you put a ; at the end of each 


EOF

$starting_URL     = $http_server_and_port.$rel_cgi_dir;

$reg_gateways     = $abs_cgi_dir.$rel_cgi_dir;
$sec_gateways     = $abs_cgi_dir.$rel_secure_cgi_dir;
$adm_gateways     = $abs_cgi_dir.$rel_admin_cgi_dir;
$cron_gateways    = $abs_cgi_dir.$rel_cron_dir;
$adm_source       = $abs_cgi_dir.$adm_src;

$reg_gateways_lib = $reg_gateways."lib";
$sec_gateways_lib = $sec_gateways."lib";
$adm_gateways_lib = $adm_gateways."lib";

$online_help      = $doc_install_dir;
$data_dir         = $data_dir;
$notices          = $notice_dir;
$database         = $db_dir;

# @newdirs --
# 
# List of new directories that will need to be created 
# 

@newdirs = ($package_dir,   $abs_cgi_dir, 
	    $reg_gateways,  $reg_gateways_lib,
	    $sec_gateways,  $sec_gateways_lib,
	    $adm_gateways,  $adm_gateways_lib,
	    $cron_gateways, $adm_source,
	    $log_files_dir, $passwd_dir, 
	    $online_help,   $data_dir, 
	    $notices,       $database);


# %copydirs --
#
# Installation copies from the distribution directories to the 
# into the installation locations. This array relates the distribution
# directories (keys) to the installation locations (values)
#
#               key                value

%copydir = ('./cgi-reg',        $reg_gateways,
            './cgi-reg/lib',    $reg_gateways_lib,
            './cgi-secure',     $sec_gateways,
            './cgi-secure/lib', $sec_gateways_lib,
            './admin',          $adm_gateways,
            './admin-src',      $adm_source,
            './admin/lib',      $adm_gateways_lib,
            './mail+news',      $cron_gateways,
            './Template',       $data_dir,
            './db_dir',         $database,
            './logs',           $log_files_dir,
            './passwd',         $passwd_dir,
	    './help_docs',      $online_help);

#
# %linkdir
#
# Array of symlinks to create: link key --> value
#
#               key                value

%linkdir = ($package_dir,     $package, 
	    $doc_install_dir, $documents);

$config    = $reg_gateways_lib."/configure.ph";
$conf_adm  = $adm_gateways_lib."/config_adm.ph";
$conf_cron = $cron_gateways."config_cron.ph";

%headers = ('configure.ph',   $config,
            'config_adm.ph',  $conf_adm,
            'config_cron.ph', $conf_cron);

#
# Remove trailing slashes (/) from @newdirs so mkdir() works properly
#

foreach (@newdirs)  { s/(.*)\/$/$1/; }

#
# Remove trailing slashes (/) from %copydir values so paths to files
# are properly calculated
#

foreach (keys(%copydir)) { 
	 $copydir{$_} =~ s/(.*)\/$/$1/; 
         $copydir{$_} =~ s/\/\//\//; 
}
#
# Remove trailing slashes (/) from %linkdir values so paths to files
# are properly calculated
#

foreach (keys(%linkdir)) { 
	 $linkdir{$_} =~ s/(.*)\/$/$1/; 
         $linkdir{$_} =~ s/\/\//\//; 
}


# DEbug block to print out names --
#
# print "Newdirs \n\n";
# foreach (@newdirs) { print "$_\n";; }
print "Copydirs \n\n";
foreach (keys(%copydir)) { print "$_	$copydir{$_}\n"; }


print " --------- CONFIGURATION SETTINGS -------------------------\n\n";
print "HTTP SERVER AND PORT:  $http_server_and_port\n\n";

print "ROOT GATEWAY PROGRAM DIRECTORY: $abs_cgi_dir\n";
print "Unrestricted, restricted (postings control) administrative,\n";
print "and cron programs go in:\n";
print "   $reg_gateways\n";
print "   $sec_gateways\n";
print "   $adm_gateways\n";
print "   $cron_gateways\n";
print "ONLINE HELP DOCUMENT DIRECTORY:\n";
print "Online HTML help goes in:\n";
print "   $online_help\n\n";
print "ROOT DATA DIRECTORY: $data_dir\n";
print "HTML document templates, notices entries, administrative\n";
print "database files, log files and password files  go in:\n";
print "   $data_dir\n";
print "   $notices\n";
print "   $database\n";
print "   $log_files_dir\n";
print "   $log_password_dir\n\n";


print "Are the above directories correct [Y or N]? ";
$string = <STDIN>;

if( $string =~ /^n/i ) { 
    print "***\n Installation aborted at your request.\n Edit the Configuration files and try again.\n***\n";
    die;
}

foreach (@newdirs) {
  if (!(-d  $_) ) {
    print "Creating $_......\n";
    if( !mkdir($_, 0755) ) {
       print 'Unable to create directory  $_\n  ---- you may need to make a parent directory by hand\n';
       die "Unable to create directory $_\n ---- you may need to make a parent directory by hand\n";
    }
  }
}

foreach $local (keys(%copydir)) {
   if( !opendir(DIR, $local)) {
        die "Unable to open file $local\n"; }
   @tmp = readdir(DIR);
   @filenames = ();
   foreach (@tmp) {
#       push(@filenames,$_) if -T $local."/".$_;
       push(@filenames,$_) if -f $local."/".$_;
   }
   close(DIR);
   print "...Copying: $local/*  To: $copydir{$local}/*\n";
   foreach $file (@filenames) {
       $infile =  $local."/".$file;
       $outfile = $copydir{$local}."/".$file;
       if($local =~ /help_docs/ )  { print  "...... File = $file\n"; }
       if($file =~ /gif$/ ) {                      # just copy GIFs
	  system("cp $infile $outfile");
	  print ".... ***** Doing file $infile \n";
       }
       else {
          @input = ();
          open(IN_FILE, "$infile");
              @input = <IN_FILE>;
          close(IN_FILE);
          if( ($file =~ /\.pl$/) || ($file =~ /\.c$/) ) {                  # insert proper perl path
LOOP:	      foreach $line (@input) {
                 $line =~ s/#! \/usr\/local\/bin\/perl/$perlpath/;
		 $line =~ s/\/cgi-reg\//$rel_cgi_dir/;
		 $line =~ s/\/cgi-secure\//$rel_secure_cgi_dir/;
		 $line =~ s/\/admin\//$rel_admin_cgi_dir/;
#                 if( $line 
#		    =~ s/#! \/usr\/local\/bin\/perl/$perlpath/) { last LOOP; }
              }
          }
          if( $local =~ /help_docs/) {             # edit help docs
	     foreach (@input) {
	      $_ =~ s/\<NOTICE_MANAGER_NAME\>/$notice_manager_name/g;
	      $_ =~ s/\<EMAIL_ADDRESS\>/$email_address/g;
	      $_ =~ s/\<PHONE_NUMBER\>/$phone_number/g;
	      $_ =~ 
	      s/http:\/\/peano.hprc.utoronto.ca:8080\/cgi-reg\//$starting_URL/g;
             }
          }
          if ($file =~ /-skel/ ) {
	       $outfile =~ s/-skel//;
	       foreach(@input) {
	         s/USER_PASSWD_FILE/$user_passwd_file/;
	         s/USER_LOG_FILE/$passwd_log_file/;
               }
          }
          open(OUT_FILE, "> $outfile");
          print OUT_FILE @input;
          close(OUT_FILE);
          if( $file =~ /\.pl$/) { chmod 0755, $outfile; }
        }
    }
}


print "Copy header files :\n\n";

foreach $local (keys(%headers)) {
   print "copying Header file $local.....\n";
   @input = ();
   open(IN_FILE, "< $local" );
   @input = <IN_FILE>;
   close(IN_FILE);
   open(OUT_FILE, "> $headers{$local}");
   print OUT_FILE @input;
   close(OUT_FILE);
}

print "\n\nOk, Installation is finished. Now create symlinks\n";

foreach $local (keys(%linkdir)) {
     if( -l $linkdir{$local} ) { 
        unlink($linkdir{$local}); 
     }
     else {
	if( -d $linkdir{$local} ) {
            $tmp = $linkdir{$local}."-1.0";
            $cmd = "mv $linkdir{$local}  $tmp";
            print "Directory $linkdir{$local} already exists: moving it to\n";
            print "$tmp\n";
	    if (-e $tmp ) {
       	       print "Ooops -- $tmp already exists. You had better move it\n";
       	       print "yourself, and rerun the in install program.\n";
	       die;
	    }
	    else {
	       system($cmd);
           }
        }
     }
     symlink($local, $linkdir{$local}) ;
     print "Linked $linkdir{$local} --> $local\n";
}


$sec_gateway_nos = $sec_gateways;
$reg_gateway_nos = $reg_gateways;
$adm_gateway_nos = $adm_gateways;

$adm_gateway_nos =~ s/\/$//;
$reg_gateway_nos =~ s/\/$//;
$adm_gateway_nos =~ s/\/$//;


print STDOUT <<EOF;

     	         **** CAREFULLY READ THE FOLLOWING ****

                                 and --

   *** READ THE FILE README.local_install TO FIND OUT WHAT TO DO NEXT ***

   Installation is nearly finished. At this point you need to go in
   and hand edit some files, and compile a few CGI programs.  If you
   are upgrading from WebNotice Version 1.0 you will also need to copy
   some configuration files into the new version. Instructions for both
   cases are found in the file "README.local_install", which is being
   created by this program. Please read this document carefully, and 
   follow the appropriate instructions.

Ian.
23/May/1996

EOF



open(FINISH, "> README.local_install");
print FINISH <<EOF;

                  **** CAREFULLY READ THE FOLLOWING ****

Installation is nearly finished.  If you are upgrading from WebNotice 
1.0, or installing WebNotice for the first time, you will need to do
(or at least check) the following four things: 

1. Compile C language gateways  ---- 

   1.1 Change to the directory:
          $adm_source 
       and configure the Makefile for your platform. 
   1.2 Edit the program change-passwd.c and make sure the 'realm' is set
       properly. The default value is "RegPasswds" (you can search the file
       to find this string. The correct value is $reg_realm -- they may
       be equivalent, in which case you can move on to step 1.3 without
       changing the file.
   1.3 make the programs by typing the command "make all". THis will also
       install the programs in the correct locations.

1b. Configure Perl Sorting Programs
   
   The lists of departments is sorted alphabetically for display, but
   you have the choice of having this sort ignore certain words: this
   wordlist is stored in the library $rel_cgi_dir/lib/inverselist.pl.
   You should edit this file to add any words you want removed from
   the sort.

2. Add the unsecure gateway programs to the Server Configuration
   Files.  With the NCSA server or Apache you need to add the following 
   line to the configuration file "srm.conf" (If you are upgrading from 
   WebNotice 1.0, This may already be done):

     ScriptAlias $rel_cgi_dir  $reg_gateways

   If you are upgrading from WebNotice 1.0, This may already be done.

3. You also need to add the *secure* gateway programs (password protected).
   With the NCSA or Apache HTTP servers you need to add the following line to
   the configuration file "srm.conf" (If you are upgrading from WebNotice 
   1.0, This may already be done):

   ScriptAlias $rel_secure_cgi_dir  $sec_gateways
   ScriptAlias $rel_admin_cgi_dir   $adm_gateways


4. Security Protect the secure programs --  With the NCSA or Apache
   HTTPD servers you need to edit the file "access.conf" and add access
   control information ((If you are upgrading from WebNotice 1.0,
   this may already be properly set).

   For the cgi-secure/ files you need to add the lines:

   <Directory $sec_gateway_nos>
      AuthType Basic
      AuthUserFile $user_passwd_file
      AuthName $reg_realm
      <Limit POST>
      require valid-user
   </Limit>
   </Directory>

   For the admin files you need to add the lines:

   <Directory $adm_gateway_nos>
      AuthType Basic
      AuthUserFile  $adm_passwd_file
      AuthName $adm_realm
      <Limit GET>
         require valid-user
         order deny,allow
         allow from valid.sub.dom  
      </Limit>
      <Limit POST>
         require valid-user
         order deny,allow
         allow from valid.sub.dom
      </Limit>
   </Directory>

   The "order deny,allow" stuff restricts accesses to certain IP domains.
   If you don't want this, just replace the "order" and "allow" lines by

         order allow,deny
         allow from all

  ****  Note/Reminder  ****
  
     The superusers password file "adm_passwd" is entirely edited by hand,
     using the htpasswd (this is an NCSA program: different servers may come
     with a different program) program to create new entries -- there is no 
     web access to this file.


*********************************************************************
IF YOU ARE  INSTALLING WEBNOTICE FOR THE FIRST TIME DO STEPS 5 -- 7.
IF YOU ARE UPGRADING FROM WEBNOTICE 1.0 SKIP TO STEP 8.
*********************************************************************

5. Test the system.  The system is delivered with example configuration
   and password files, with names of the form "filename.ext-dist".  To 
   install these you must do the following:

     a) change to the package password directory $passwd_dir
	and copy the -dist files in place. That is:

             cp adm_password-dist adm_password
             cp sem_password-dist sem_password

     b) change to the package configuration directory $database
	and copy the -dist files in place. That is:

             cp  groups.conf-dist       groups.conf
             cp  newsgroups.conf-dist   newsgroups.conf
             cp  seminar.conf-dist	seminar.conf
             cp  listservs.conf-dist    listservs.conf
             cp  seminar-2.conf-dist	seminar-2.conf
		 
   The distribution files are preconfigured with two departments,
   two associated super users, two departmental groups with associated 
   regular users, along with the associated password files (located 
   in $passwd_dir).  
   The departments, the associated superusers  and their passwords are:

       DEPARTMENT                 SUPERUSER NAME      SUPERUSER PASSWORD

    Department of Statistics       superblobby             blobby
    Department of Philosophy       superkant               kant

   The groups associated with these two departments (along with the names
   and passwords of users allowed to deposit notices) are:
 
   A)  Department  of Statistics
       GROUP                                    USER NAME   USER PASSWORD
       Department                                 blobby       blobby
       Institute for Interdisciplinary Studies    blobby       blobby
 
   B)  Department of Philosophy
       GROUP                                    USER NAME   USER PASSWORD
       Department                                  kant         kant
 
 
   You should try adding notices, changing configuration files, etc,
   to verify that things work and that authentication is being properly
   checked. 

6. Once this has been verified, you will have to delete the test users
   from the password files, and also the test departments, groups
   listservs and newsgroups from the configuration files. 
   
   You must then, by hand, create the departments, the associated superusers
   (and their password). As the manage, you are must also, by hand, maintain
   the lists of allowed groups (groups.conf), listservs/mailing list
   (listservs.conf) and newsgroups (newsgroups.conf).  Once this is done, 
   each superuser can configure their own departments as they see fit, using
   this information.

  *** NOTE 1: NEW DEPARTMENTS ***
      When you create a new department you must edit, by hand,  the files
      seminar.conf to create the department (and a short keyword for the
      department) and the file seminar-2.conf to create the basic groups
      template. In file seminar-2.conf you must create a block such as:
  
      <keyword>  super_user_name
        Department : users : :
      </keyword>
  
      This can subsequently be edited by the allowed superusers, using the
      superuser's restricted-access forms.

  *** NOTE 2: NEW GROUPS, LISTSERVS and NEWSGROUPS ***
      When you give access to new groups, listservs or newsgroups, you 
      must, by hand, add relevant information to the documentation pages.
      These documents are found in the document directory:
      $doc_install_dir, and have the names 

	    groups_info.html     (information about cross-departmental groups)
	    lists_info.html      (information about listservs/mailing lists)
	    news_info.html       (information about newsgroups)

7. Install the crontab entries for the cron programs. There are several
   cron programs that (i) remove expired notices, (ii) mail notices to the
   appropriate listservs, etc.  To run these programs, you must add entries
   into the computer's cron table. Some suggested entries are found
   in the file "cron_entries". See the README file in the mail+news
   directory for more information.

And you are finished.

*********************************************************************
        IF YOU ARE UPGRADING FROM A PREVIOUS VERSION OF WEBNOTICE, 
			 DO STEPS 8 and 9
*********************************************************************

8. To complete the upgrade, you need to copy over all the notices, password,
   configuration and log files from the old package to the new.  

   a) copy *all* notice files from the old notices/  directory into the
      new directory $notices
 
   b) copy *all* log files from the old logs/ log file directory into the new
      directory $log_files_dir
 
   c) copy *all* password files from the old passwd/ password file directory 
      into the new directory $passwd_dir
 
   d) copy the old configuration files groups.conf, listservs.conf, 
      newsgroups.conf, seminar-2.conf,  and seminar.conf into the new 
      into the new database directory $database

   e) Modify the online help documents groups_info.html, lists_info.html 
      and news_info.html (found in the directory
      $doc_install_dir)
      to reflect the groups, mailing lists and newsgroups supported by
      your configuration files.
 
   Now, test the system, to make sure it is all working properly. 

7. Install the crontab entries for the cron programs. There are several
   cron programs that (i) remove expired notices, (ii) mail notices to the
   appropriate listservs, etc -- these have changed somewhat from Version
   1.0. Sorry, but I still do not have programs for posting notices to
   newsgroups.
   Some suggested cron entries are found in the file "cron_entries". See 
   the README file in the mail+news directory for more information.

Your are finished!

EOF

close(FINISH);

