#! /usr/local/bin/perl

{
}

sub extract_short_mail_entry {

   local($db_file, *dept_list,  *dept_group_list, 
	           *dept_group, *entry) = @_;

   local ($input, $dept, $date, $time, $speak, $title, $tmp, $organ);
   local ($image, $alt);
   local (@input, $new_date, $new_time, $linkto);

   if($DEBUG) {print " --- INSIDE extract_short_mail_entry- File: $db_file\n";}

   @input = ();
   @entry = ();

   &read_db_file($db_file, *array);

   $organ2 = $array{"organ_type"};
   $organ2 =~ s/ /_/g;
   $dept_group = $array{"dept"}.":".$organ2;

   if($DEBUG) {
      print "Dept_group = $dept_group\n";
      print "Dept_group_list{arg} is ---- \n";

      foreach (keys(%dept_group_list)) {
#         if( $dept =~ $_) { 
              print "       $_ +++ $dept_group_list{$_}\n";
#         }
      }
   }

   if ($dept_group_list{$dept_group} eq "" ) {
       $error_code = 2;            # Group has no associated listserv(s)
 				  # or event has been moved/deleted/cancelled
       if($DEBUG){ print "............ Group has no associated listserv(s)\n";}
       @entry = ();
       return "false";
   }
   if ($array{"modified"} eq "moved" || $array{"modified"} eq "delete") {
       $array{"other_info"} =~ s/<\w*>//g;
       $array{"other_info"} =~ s/<\/\w*>//g;
       $array{"other_info"} =~ s/<.*>//g;
       $array{"locat"}      =~ s/<\w*>//g;
       $array{"locat"}      =~ s/<\/\w*>//g;
       $array{"locat"}      =~ s/<.*>//g;
   }
   $line_width=80;
   &create_compact_mail_notice($line_width, *dept_list, *array, *entry);
}

# --------------------------------------------------------------------

sub write_list_header {
  local($list, $full_file, $date_start, $date_stop) = @_;
  local($header, $line_width);
  $line_width = 80;
  $tmp     = "WebNotice System: Mailing to list: $list"; 
  $header  = &text_center($line_width, $tmp)."\n";;
  $tmp     = "Events For $date_start to $date_stop";
  $header .= &text_center($line_width, $tmp)."\n";
  $tmp     = "For additional information see:";
  $header .= &text_center($line_width, $tmp);
  $tmp     = $http_server_and_port.$rel_cgi_dir."notices_main.pl";
  $header .= &text_center($line_width, $tmp)."\n";
  $header .= &horiz_line_centred($line_width, 50);
  if( !open(FILEOUT, "> $full_file")) {
      &mf_error("Unable to open listserv tmp file $full_file",
		     __LINE__, __FILE__); 
  }
  print FILEOUT  "$header";
  close(FILEOUT);
}

sub write_list_entry {
  local($list, $full_file, *entry) = @_;
  if( !open(FILEOUT, ">> $full_file")) {
      &mf_error("Unable to open listserv tmp file $full_file",
		     __LINE__, __FILE__); 
  }
  foreach(@entry) { print FILEOUT $_; }
  close(FILEOUT);
}
1;


sub create_compact_mail_notice {

  local($line_width, *dept_list, *array, *page) = @_;

  local($num_year, $num_month, $num_day, @tmp, $num_date);
  local($time_date);
  local($department);

  foreach(keys(%array)){
     $tmp = $array{$_};
     &isotoasc(*tmp);
     $array{$_} = $tmp;
  }

  $department = $dept_list{$array{"dept"}};
  $department =~ s/ *$//;

  if( $DEBUG ) { print " Made it to sponsor......\n"; }
					    # Create formatted date and time
					    # fields for TITLE and body of
					    # the notice.
  ($num_year, $num_month, $num_day, @tmp) = 
	   split(/ /,$array{"time_date_string"});
  $num_date  = ($num_day)."-".($num_month+1)."-".($num_year);
  $time_date = $array{"date"}." at ".$array{"time"};

  if($array{"modified"} eq "moved") {
     $time_date .= " - ** MOVED TO NEW TIME/DATE (see below) **"
  }
     
  if($array{"modified"} eq "delete") {
     $time_date .= " - ** EVENT CANCELLED **"
  }

  
                                            # If a subdepartment was specified
					    # add this information to the 
					    # department string 
  if( $array{"organ_type"} !~ /department/i ) {
     $department .= " - ".$array{"organ_type"};
  }

  if( $DEBUG ) { 
	 print " subject    = $subject\n"; 
	 print " Department = $department\n"; 
	 print " Num_date   = $num_date\n"; 
   }

  if( $DEBUG ) {  print "FOO.1 -- Event-type =  $array{\"event_type\"}\n"; }
  if( $DEBUG ) {  print "FOO.2 =  $foo\n"; }

  $indent=0;
  $hangindent=0;
  $para_pad = "";
  $tmp = $time_date;
    push(@page, "\n".&align($indent, $hangindent, $para_pad, $line_width, $tmp));

  $tmp = "$department: $array{\"event_type\"}";
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp));

  push(@page, "\n");
  $indent=3;
  $hangindent=10;
  $tmp = "Title:    \"$array{\"t_title\"}\"";
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp));

  $tmp = "Speaker:  $array{\"speak\"}, $array{\"affil\"}" ;
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp));

  $tmp = "Location: $array{\"locat\"}";
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp));

  if ( $array{"other_info"} ne "" ) {
  $tmp = "Remarks:  $array{\"other_info\"}";
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
  }

  $tmp = "Abstract:"; 
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
  $indent=5;
  $hangindent=0;
  $tmp = $array{"t_abstract"};
    push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );

  if( $DEBUG ) { print " Made it to sponsor......\n"; }

  $indent=3;
  $hangindent=0;
  if( $array{"sponsor"} =~ /\S+/ ) {
      push(@page, "\n");
      $tmp = "Talk Sponsored by: $array{\"sponsor\"}";
      push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
  }
  $hangindent=10;
  if( ($array{"info_name"}  =~ /\S+/) || ($array{"info_email"} =~ /\S+/) ||
      ($array{"info_phone"} =~ /\S+/) || ($array{"info_www"}   =~ /\S+/) ) {
      push(@page, "\n");
      $tmp = "For additional Information, Contact:";
        push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
      $indent=8;
      if( $array{"info_name"} =~ /\S+/)  {
	 $tmp = "Name:   $array{\"info_name\"}";
	 push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
      }
      if( $array{"info_email"} =~ /\S+/)  {
	 $tmp = "E-mail: $array{\"info_email\"}";
         push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
      }
      if( $array{"info_phone"} =~ /\S+/)  {
	 $tmp = "Phone:  $array{\"info_phone\"}";
         push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
      }
      if( $array{"info_www"} =~ /\S+/)  {
	 $tmp = "URL:    $array{\"info_www\"}";
         push(@page, &align($indent, $hangindent, $para_pad, $line_width, $tmp) );
      }
  }
  $tmp = "\n".&horiz_line(40);
  push(@page, $tmp);

}
